﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace BoxingTest
{
    struct RGB
    {
        public int red;
        public int green;
        public int blue;

        public RGB(int red, int green, int blue)
        {
            this.red = red;
            this.green = green;
            this.blue = blue;
        }

        public override string ToString()
        {
            return red.ToString("X") + green.ToString("X") + blue.ToString("X");
        }
    }

    class Program
    {
        static ArrayList boxValue;
        static List<RGB> noBoxValue;

        static void Main(string[] args)
        {
            DateTime start;
            DateTime middle;
            TimeSpan end;

            RGB rgb = new RGB(255, 255, 255);

            #region None Boxing
            Console.WriteLine("박싱되지 않는 List<RGB>.Add(RGB)");
            noBoxValue = new List<RGB>();

            start = DateTime.Now;

            for (int i = 0; i < 10000000; i++)
                noBoxValue.Add(rgb);

            middle = DateTime.Now;

            end = middle - start;
            Console.WriteLine("시작 = {0}, 끝 = {1}, 경과시간 = {2}", start.ToString("hh:mm:ss"),
                                                                      middle.ToString("hh:mm:ss"),
                                                                      end.ToString());
            #endregion

            #region Boxing
            Console.WriteLine("박싱되는 ArrayList.Add(object)");
            boxValue = new ArrayList();

            start = DateTime.Now;

            for (int i = 0; i < 10000000; i++)
                boxValue.Add(rgb);

            middle = DateTime.Now;
            end = middle - start;

            Console.WriteLine("시작 = {0}, 끝 = {1}, 경과시간 = {2}", start.ToString("hh:mm:ss"),
                                                                      middle.ToString("hh:mm:ss"),
                                                                      end.ToString());
            #endregion
        }
    }
}
